'Menu_Driven_Object_GG-2016_REV2.spin

{{ REV2 is what I believe, a properly working Object.
        I cannot get this object to screw up in any manner.

   REV1 was used to test Kwinn's explanation concerning program flow.
   THIS WORKS VERY GOOD!
}}
{{  This is a simple Menu selection Object.
    On microcontroller boot-up the LCD is set to the menu display.
    Pressing BUTN4 will advance the selections to different Menu selections.
    After the proper Menu item is selected and showing on the display.
    Pressing BUTN1 will send the code to the proper method 1, 2, or 3.

    After the method is completed.
    Pressing BUTN1 takes the program back to the menue selection.
}}
{{
       'The following 3 lines are just a test point, to be erased when things are working correctly
       This can be inserted anyplace in the Object temporarily to troubleshoot my coding errors.
     LCD.TX(128)                                       'Move cursor to Line0 position 0 
     LCD.str(string("test point #1   "))               ' This is a test marker.           
     Waitpeq (|<BUTN2, |<BUTN2, 0)          'Pause program execution until button BUTN2 is pressed .   

}}
CON
' Set Processor Speed @ 80mhz
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

' Lcd Pin Assignment
  LCD_Pin = 18
' Global Pin Assignments for Pushbuttons
' Pushbuttons start at the bottom of the board.                           
  BUTN1 = 8
  BUTN2 = 9
  BUTN3 = 10
  BUTN4 = 11
   
VAR
 
  Long Flag1           'Flag for BUTN1
  Long Flag2           'Flag for BUTN2 
  Long Flag3           'Flag for BUTN3                       
  Long Flag4           'Flag for BUTN4                      
  Long MENUE           'Variable used to reach the proper menu selection, 1,2 or 3 and
                       ' to allow exit of repeat loop in MAIN_MENUE
  Long mask          'Used to set up the Waitpne instruction in MainMenue method
   

OBJ
  ' FullDuplexSerial will be used to drive the Parallax 2 line LCD display
  
  LCD : "FullDuplexSerial"
                    
PUB  Main 

waitcnt(clkfreq * 3 + cnt)             ' 3sec Delay Before Starting   

  Flag1:=0           'Flag for BUTN1
  Flag2:=0           'Flag for BUTN2 
  Flag3:=0           'Flag for BUTN3                       
  Flag4:=0           'Flag for BUTN4         
  MENUE:=0          'Sets MENUE variable to 1 which is the lowest menu number for this situation.

     'Make BUTN1 through BUTN4 an input. 
dira[BUTN1] := 0
dira[BUTN2] := 0                              '
dira[BUTN3] := 0
dira[BUTN4] := 0

  mask := (|<BUTN1) | (|<BUTN4)  'OR the two button masks together into a single value.  Used in the MainMenue method.      

  LCD.start(LCD_Pin, LCD_Pin, %1000, 9_600)  'This is setting for LCD display.
  waitcnt(clkfreq / 10 + cnt)                ' Pause for 100ms to initialize the LCD display.  


  repeat       'This is from KWINN on parallax forum.  It should help with program flow.

    MAIN_MENUE                                   ' Calls the next method

              'Program returns here from MAIN_MENUE - Per Kwinn on parallax forum.                       
pub MAIN_MENUE



     'Set up and display initial MENUE LCD view.
       LCD.tx(12)                            ' Clear the LCD display
       waitcnt (60_000 + cnt)                ' Pause for 5ms time for LCD display to clear
  
       LCD.str(string("MENU"))               ' line 0 printed to LCD                                      
       LCD.tx(13)                            ' Line feed
       LCD.str(string("BUTN4 = Select"))     ' line 1 printed to LCD
       LCD.tx(212)                           ' Set quarter note
       LCD.tx(220)                           ' A tone             
       MENUE:=0                              'Needed to reinitialize variable MENUE
 
 repeat                     
            IF MENUE==4                      'MENUE:=4 Is set as last statement before returning from
               QUIT                          '         the FirstMenue, SecondMenue and ThirdMenue methods. 


            Waitpne (|<BUTN1, |<BUTN1, 0)          'Pause program execution until button BUTN1 is NOT pressed . 
            If INA[BUTN1]==0                       'BUTN1 must be released to enable BUTN1 again.
               Flag1:=0                            'Flag1 says that the BUTN1 has been released. 
            If INA[BUTN4]==0                       'BUTN4 must be released to enable BUTN4 again.
               Flag4:=0                            'Flag4 says that the BUTN4 has been released.
                            
            waitpne(  0 , mask , 0 )       'wait for either BUTN1 or BUTN4 to be set. mask is defined in the VAR section.      
                                           'mask is defined in the VAR section. 

            IF INA[BUTN4]==1 and Flag4==0

                   Flag4:=1

                   MENUE:= MENUE+1

                    IF MENUE>3
                       MENUE:=1         

       if Flag4==1   
          Case MENUE
            1 : 
                LCD.TX(12)                          'Clear the LCD screen.
                waitcnt(clkfreq / 200 + cnt)        'Wait 5ms for screen to clear.  This is 1 / 0.005 seconds  
                LCD.str(String("To 1st Menu?"))             
                LCD.TX(148)                         'Move cursor to Line1 position 0
                LCD.str(String("                ")) 'Print 16 spaces to clear line 1                
                LCD.TX(148)                         'Move cursor to Line1 position 0               
                LCD.str(String("GoTo = BUTN1"))     'Instruction to go to this method                                               
            2 : 
                LCD.TX(12)                          'Clear the LCD screen.
                waitcnt(clkfreq / 200 + cnt)        'Wait 5ms for screen to clear.  This is 1 / 0.005 seconds  
                LCD.str(String("To 2nd Menu?"))      
                LCD.TX(148)                         'Move cursor to Line1 position 0
                LCD.str(String("                ")) 'Print 16 spaces to clear line 1                
                LCD.TX(148)                         'Move cursor to Line1 position 0               
                LCD.str(String("GoTo = BUTN1"))     'Instruction to go to this method                             
            3 :
                LCD.TX(12)                          'Clear the LCD screen.
                waitcnt(clkfreq / 200 + cnt)        'Wait 5ms for screen to clear.  This is 1 / 0.005 seconds  
                LCD.str(String("To 3rd Menu?"))      
                LCD.TX(148)                         'Move cursor to Line1 position 0
                LCD.str(String("                ")) 'Print 16 spaces to clear line 1                
                LCD.TX(148)                         'Move cursor to Line1 position 0               
                LCD.str(String("GoTo = BUTN1"))     'Instruction to go to this method       

        Flag4:=2                                    'Flag4:=2 is used so the Case MENU does not keep repeating.
                                                    'This stops the MENUE from updating if BUTN4 is staying pressed.
   
       If INA[BUTN1]==1 and Flag1==0

                    Flag1:=1            

           Case MENUE                 '"Case MENUE" sends program to the proper method.
              1 : FirstMenue       

              2 : SecondMenue      
                                   
              3 : ThirdMenue       

      
 'Program returns here from either FirstMenue, SecondMenue or ThirdMenue.
 'THEN the program returns to Main because MENUE is set to 4 at the end of FirstMenue,SecondMenue & ThirdMenue. 
pub FirstMenue

                LCD.TX(128)                         'Move cursor to Line0 position 0
                LCD.str(String("                ")) 'Print 16 spaces to clear line 0
                LCD.TX(128)                         'Move cursor to Line0 position 0  
                LCD.str(String("In FirstMenue !!")) 'This proves I'm in the FirstMenue method.
                LCD.TX(148)                         'Move cursor to Line1 position 0
                LCD.str(String("                ")) 'Print 16 spaces to clear line 1                
                LCD.TX(148)                         'Move cursor to Line1 position 0               
                LCD.str(String("Exit = BUTN1"))     'Instruction to leave this method

  Waitpne (|<BUTN1, |<BUTN1, 0)          'Pause program execution until button BUTN1 is NOT pressed .  
  Waitpeq (|<BUTN1, |<BUTN1, 0)          'Pause program execution until button BUTN1 is pressed and held.  

  MENUE:=4       'If MENUE is equal to 4, the implied return sends program back to MAIN_MENUE, where the
                'repeat loop is canceled.
                 

{{ Once the code is finished running in this method, program will automatically return to Main_Menue.}}
                      
pub SecondMenue                               

                LCD.TX(128)                         'Move cursor to Line0 position 0
                LCD.str(String("                ")) 'Print 16 spaces to clear line 0
                LCD.TX(128)                         'Move cursor to Line0 position 0  
                LCD.str(String("In SecondMenue !")) 'This proves I'm in the SecondMenue method.
                LCD.TX(148)                         'Move cursor to Line1 position 0
                LCD.str(String("                ")) 'Print 16 spaces to clear line 1                
                LCD.TX(148)                         'Move cursor to Line1 position 0               
                LCD.str(String("Exit = BUTN1"))     'Instruction to leave this method

  Waitpne (|<BUTN1, |<BUTN1, 0)          'Pause program execution until button ina[8] is NOT pressed .  
  Waitpeq (|<BUTN1, |<BUTN1, 0)          'Pause program execution until button ina[8] is pressed and held.  

 MENUE:=4       'If MENUE is equal to 4, the implied return sends program back to MAIN_MENUE, where the
                'repeat loop is canceled. 
     
{{ Once the code is finished running in this method, program will automatically return to Main_Menue.}}
                          
pub ThirdMenue

                LCD.TX(128)                         'Move cursor to Line0 position 0
                LCD.str(String("                ")) 'Print 16 spaces to clear line 0
                LCD.TX(128)                         'Move cursor to Line0 position 0  
                LCD.str(String("In ThirdMenue !!")) 'This proves I'm in the ThirdMenue method.
                LCD.TX(148)                         'Move cursor to Line1 position 0
                LCD.str(String("                ")) 'Print 16 spaces to clear line 1                
                LCD.TX(148)                         'Move cursor to Line1 position 0               
                LCD.str(String("Exit = BUTN1"))     'Instruction to leave this method 

  Waitpne (|<BUTN1, |<BUTN1, 0)          'Pause program execution until button ina[8] is NOT pressed .  
  Waitpeq (|<BUTN1, |<BUTN1, 0)          'Pause program execution until button ina[8] is pressed and held.  

 MENUE:=4       'If MENUE is equal to 4, the implied return sends program back to MAIN_MENUE, where the
                'repeat loop is canceled.   
     
{{ Once the code is finished running in this method, program will automatically return to Main_Menue.}}
                                                   